package net.ibizsys.central.plugin.boot.core.runtime;

import net.ibizsys.central.dataentity.IDataEntityRuntimeContext;
import net.ibizsys.central.dataentity.service.IDEService;
import net.ibizsys.central.plugin.boot.core.domain.BaseData;
import net.ibizsys.central.plugin.boot.core.filter.BaseFilter;
import net.ibizsys.central.plugin.boot.core.helper.StringAdvUtils;
import net.ibizsys.central.plugin.boot.core.service.IBaseService;
import net.ibizsys.central.util.EntityDTO;
import net.ibizsys.central.util.IEntityDTO;
import net.ibizsys.central.util.ISearchContextDTO;
import net.ibizsys.central.util.SearchContextDTO;
import net.ibizsys.model.dataentity.action.IPSDEAction;
import net.ibizsys.model.dataentity.ds.IPSDEDataSet;
import net.ibizsys.model.dataentity.service.IPSDEMethodDTO;
import org.springframework.util.Assert;

import java.lang.reflect.*;

public interface IBootService<T extends BaseData, F extends BaseFilter> extends IDEService {

    IBootSystemRuntime getSystemRuntime();

    void setSystemRuntime(IBootSystemRuntime systemRuntime);


    IBaseService getBaseService();

    default IDataEntityRuntimeContext getDataEntityRuntimeContext() {
        return null;
    }

    default void setDataEntityRuntimeContext(IDataEntityRuntimeContext dataEntityRuntimeContext) { }


}

