package net.ibizsys.central.plugin.boot.core.service.impl;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import net.ibizsys.central.plugin.boot.core.domain.BaseData;
import net.ibizsys.central.plugin.boot.core.filter.BaseFilter;
import net.ibizsys.central.plugin.boot.core.runtime.BootServiceImpl;
import net.ibizsys.central.plugin.boot.core.service.IBaseService;
import net.ibizsys.central.plugin.boot.core.service.IMPService;
import net.ibizsys.central.plugin.boot.core.service.IServiceApiService;
import org.apache.commons.lang3.ObjectUtils;
import org.springframework.beans.factory.annotation.Autowired;

import javax.annotation.PostConstruct;
import java.lang.reflect.ParameterizedType;


public  abstract class MPServiceImpl<T extends BaseData, F extends BaseFilter, M extends BaseMapper<T>> extends BaseServiceImpl<T,F> implements IMPService<T, F, M> {

    @Autowired
    protected M baseMapper;
    public M getBaseMapper() {
        return this.baseMapper;
    }

    private Class<M> mClass;

    public Class<M> getMClass() {
        return mClass;
    }

    @PostConstruct
    protected void postConstruct() throws Exception {
        Class serviceClass=this.getClass();
        while (serviceClass!=null) {
            if(!ObjectUtils.isEmpty(serviceClass.getInterfaces())) {
                Class interfaceClass=serviceClass.getInterfaces()[0];
                if(!ObjectUtils.isEmpty(interfaceClass.getInterfaces())) {
                    if(interfaceClass.getInterfaces()[0].isAssignableFrom(IMPService.class)) {
                        serviceClass=interfaceClass;
                        break;
                    }
                }
            }
            serviceClass = serviceClass.getSuperclass();
        }
        if(!ObjectUtils.isEmpty(serviceClass.getGenericInterfaces())) {
            ParameterizedType ptype = (ParameterizedType) serviceClass.getGenericInterfaces()[0];
            mClass = (Class) ptype.getActualTypeArguments()[2];
        }
        super.postConstruct();
    }
}

